var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Chat = void 0;
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _react = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
var _useAppSettings = require("./hooks/useAppSettings");
var _useCreateChatContext = require("./hooks/useCreateChatContext");
var _useIsOnline2 = require("./hooks/useIsOnline");
var _useMutedUsers = require("./hooks/useMutedUsers");
var _ChannelsStateContext = require("../../contexts/channelsStateContext/ChannelsStateContext");
var _ChatContext = require("../../contexts/chatContext/ChatContext");
var _DebugContext = require("../../contexts/debugContext/DebugContext");
var _ThemeContext = require("../../contexts/themeContext/ThemeContext");
var _TranslationContext = require("../../contexts/translationContext/TranslationContext");
var _hooks = require("../../hooks");
var _useStreami18n = require("../../hooks/useStreami18n");
var _init = _interopRequireDefault(require("../../init"));
var _native = require("../../native");
var _OfflineDB = require("../../store/OfflineDB");
var _version = require("../../version.json");
var _jsxRuntime = require("react/jsx-runtime");
var _this = this,
  _jsxFileName = "/home/runner/work/stream-chat-react-native/stream-chat-react-native/package/src/components/Chat/Chat.tsx";
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
(0, _init.default)();
var selector = function selector(nextValue) {
  return {
    initialized: nextValue.initialized,
    userId: nextValue.userId
  };
};
var ChatWithContext = function ChatWithContext(props) {
  var _client$user2, _useStateStore, _client$offlineDb;
  var children = props.children,
    client = props.client,
    _props$closeConnectio = props.closeConnectionOnBackground,
    closeConnectionOnBackground = _props$closeConnectio === void 0 ? true : _props$closeConnectio,
    _props$enableOfflineS = props.enableOfflineSupport,
    enableOfflineSupport = _props$enableOfflineS === void 0 ? false : _props$enableOfflineS,
    i18nInstance = props.i18nInstance,
    _props$ImageComponent = props.ImageComponent,
    ImageComponent = _props$ImageComponent === void 0 ? _reactNative.Image : _props$ImageComponent,
    isMessageAIGenerated = props.isMessageAIGenerated,
    _props$LoadingIndicat = props.LoadingIndicator,
    LoadingIndicator = _props$LoadingIndicat === void 0 ? null : _props$LoadingIndicat,
    style = props.style;
  var _useState = (0, _react.useState)(),
    _useState2 = (0, _slicedToArray2.default)(_useState, 2),
    channel = _useState2[0],
    setChannel = _useState2[1];
  var translators = (0, _useStreami18n.useStreami18n)(i18nInstance);
  var translationContextValue = (0, _react.useMemo)(function () {
    var _client$user;
    return Object.assign({}, translators, {
      userLanguage: ((_client$user = client.user) == null ? void 0 : _client$user.language) || _TranslationContext.DEFAULT_USER_LANGUAGE
    });
  }, [(_client$user2 = client.user) == null ? void 0 : _client$user2.language, translators]);
  var _useIsOnline = (0, _useIsOnline2.useIsOnline)(client, closeConnectionOnBackground),
    connectionRecovering = _useIsOnline.connectionRecovering,
    isOnline = _useIsOnline.isOnline;
  var _ref = (_useStateStore = (0, _hooks.useStateStore)((_client$offlineDb = client.offlineDb) == null ? void 0 : _client$offlineDb.state, selector)) != null ? _useStateStore : {},
    offlineDbInitialized = _ref.initialized,
    offlineDbUserId = _ref.userId;
  var mutedUsers = (0, _useMutedUsers.useMutedUsers)(client);
  var debugRef = (0, _DebugContext.useDebugContext)();
  var isDebugModeEnabled = __DEV__ && debugRef && debugRef.current;
  var userID = client.userID;
  (0, _react.useEffect)(function () {
    if (client) {
      var sdkName = _native.NativeHandlers.SDK ? _native.NativeHandlers.SDK.replace('stream-chat-', '') : 'react-native';
      client.sdkIdentifier = {
        name: sdkName,
        version: _version.version
      };
      client.deviceIdentifier = {
        os: `${_reactNative.Platform.OS} ${_reactNative.Platform.Version}`
      };
      client.recoverStateOnReconnect = false;
      client.persistUserOnConnectionFailure = enableOfflineSupport;
    }
    if (isDebugModeEnabled) {
      if (debugRef.current.setEventType) {
        debugRef.current.setEventType('send');
      }
      if (debugRef.current.setSendEventParams) {
        debugRef.current.setSendEventParams({
          action: 'Client',
          data: client.user
        });
      }
    }
  }, [client, enableOfflineSupport]);
  var setActiveChannel = function setActiveChannel(newChannel) {
    return setChannel(newChannel);
  };
  (0, _react.useEffect)(function () {
    if (!(userID && enableOfflineSupport)) {
      return;
    }
    var initializeDatabase = function () {
      var _ref2 = (0, _asyncToGenerator2.default)(function* () {
        if (!client.offlineDb) {
          client.setOfflineDBApi(new _OfflineDB.OfflineDB({
            client: client
          }));
        }
        if (client.offlineDb) {
          yield client.offlineDb.init(userID);
        }
      });
      return function initializeDatabase() {
        return _ref2.apply(this, arguments);
      };
    }();
    initializeDatabase();
  }, [userID, enableOfflineSupport, client]);
  (0, _react.useEffect)(function () {
    if (!client) {
      return;
    }
    client.threads.registerSubscriptions();
    client.polls.registerSubscriptions();
    client.reminders.registerSubscriptions();
    client.reminders.initTimers();
    return function () {
      client.threads.unregisterSubscriptions();
      client.polls.unregisterSubscriptions();
      client.reminders.unregisterSubscriptions();
      client.reminders.clearTimers();
    };
  }, [client]);
  var initialisedDatabase = !!offlineDbInitialized && userID === offlineDbUserId;
  var appSettings = (0, _useAppSettings.useAppSettings)(client, isOnline, enableOfflineSupport, initialisedDatabase);
  var chatContext = (0, _useCreateChatContext.useCreateChatContext)({
    appSettings: appSettings,
    channel: channel,
    client: client,
    connectionRecovering: connectionRecovering,
    enableOfflineSupport: enableOfflineSupport,
    ImageComponent: ImageComponent,
    isMessageAIGenerated: isMessageAIGenerated,
    isOnline: isOnline,
    mutedUsers: mutedUsers,
    setActiveChannel: setActiveChannel
  });
  if (userID && enableOfflineSupport && !initialisedDatabase) {
    return LoadingIndicator ? (0, _jsxRuntime.jsx)(LoadingIndicator, {}) : null;
  }
  return (0, _jsxRuntime.jsx)(_ChatContext.ChatProvider, {
    value: chatContext,
    children: (0, _jsxRuntime.jsx)(_TranslationContext.TranslationProvider, {
      value: translationContextValue,
      children: (0, _jsxRuntime.jsx)(_ThemeContext.ThemeProvider, {
        style: style,
        children: (0, _jsxRuntime.jsx)(_ChannelsStateContext.ChannelsStateProvider, {
          children: children
        })
      })
    })
  });
};
var Chat = exports.Chat = function Chat(props) {
  var _useTheme = (0, _ThemeContext.useTheme)(),
    theme = _useTheme.theme;
  return (0, _jsxRuntime.jsx)(ChatWithContext, Object.assign({
    style: theme
  }, props));
};
//# sourceMappingURL=Chat.js.map