var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InputReplyStateHeader = void 0;
var _react = _interopRequireDefault(require("react"));
var _reactNative = require("react-native");
var _useMessageComposer = require("../../../contexts/messageInputContext/hooks/useMessageComposer");
var _ThemeContext = require("../../../contexts/themeContext/ThemeContext");
var _TranslationContext = require("../../../contexts/translationContext/TranslationContext");
var _icons = require("../../../icons");
var _jsxRuntime = require("react/jsx-runtime");
var _this = this,
  _jsxFileName = "/home/runner/work/stream-chat-react-native/stream-chat-react-native/package/src/components/MessageInput/components/InputReplyStateHeader.tsx";
var InputReplyStateHeader = exports.InputReplyStateHeader = function InputReplyStateHeader() {
  var _useTranslationContex = (0, _TranslationContext.useTranslationContext)(),
    t = _useTranslationContex.t;
  var messageComposer = (0, _useMessageComposer.useMessageComposer)();
  var _useTheme = (0, _ThemeContext.useTheme)(),
    _useTheme$theme = _useTheme.theme,
    _useTheme$theme$color = _useTheme$theme.colors,
    black = _useTheme$theme$color.black,
    grey = _useTheme$theme$color.grey,
    grey_gainsboro = _useTheme$theme$color.grey_gainsboro,
    _useTheme$theme$messa = _useTheme$theme.messageInput.editingStateHeader,
    editingBoxHeader = _useTheme$theme$messa.editingBoxHeader,
    editingBoxHeaderTitle = _useTheme$theme$messa.editingBoxHeaderTitle;
  var onCloseHandler = function onCloseHandler() {
    messageComposer.setQuotedMessage(null);
  };
  return (0, _jsxRuntime.jsxs)(_reactNative.View, {
    style: [styles.replyBoxHeader, editingBoxHeader],
    children: [(0, _jsxRuntime.jsx)(_icons.CurveLineLeftUp, {
      pathFill: grey_gainsboro
    }), (0, _jsxRuntime.jsx)(_reactNative.Text, {
      style: [styles.replyBoxHeaderTitle, {
        color: black
      }, editingBoxHeaderTitle],
      children: t('Reply to Message')
    }), (0, _jsxRuntime.jsx)(_reactNative.Pressable, {
      onPress: onCloseHandler,
      style: function style(_ref) {
        var pressed = _ref.pressed;
        return [{
          opacity: pressed ? 0.8 : 1
        }];
      },
      testID: "close-button",
      children: (0, _jsxRuntime.jsx)(_icons.CircleClose, {
        pathFill: grey
      })
    })]
  });
};
var styles = _reactNative.StyleSheet.create({
  replyBoxHeader: {
    alignItems: 'center',
    flexDirection: 'row',
    justifyContent: 'space-between',
    paddingBottom: 8
  },
  replyBoxHeaderTitle: {
    fontSize: 14,
    fontWeight: 'bold'
  }
});
InputReplyStateHeader.displayName = 'ReplyStateHeader{messageInput}';
//# sourceMappingURL=InputReplyStateHeader.js.map