import { LocalAttachment } from 'stream-chat';
import { AudioConfig } from '../../../types/types';
/**
 * Manages the state of audio attachments for preview and playback.
 * @param files The audio files to manage.
 * @returns An object containing the state and handlers for audio attachments.
 */
export declare const useAudioPreviewManager: (files: LocalAttachment[]) => {
    audioAttachmentsStateMap: Record<string, AudioConfig>;
    onLoad: (index: string, duration: number) => void;
    onPlayPause: (index: string, pausedStatus?: boolean) => void;
    onProgress: (index: string, progress: number) => void;
    setAudioAttachmentsStateMap: import("react").Dispatch<import("react").SetStateAction<Record<string, AudioConfig>>>;
};
//# sourceMappingURL=useAudioPreviewManager.d.ts.map