import React, { PropsWithChildren } from 'react';
import BottomSheet from '@gorhom/bottom-sheet';
export type AttachmentPickerIconProps = {
    numberOfImageUploads?: number;
    selectedPicker?: 'images';
};
export type AttachmentPickerContextValue = {
    /**
     * `bottomInset` determine the height of the `AttachmentPicker` and the underlying shift to the `MessageList` when it is opened.
     * This can also be set via the `setBottomInset` function provided by the `useAttachmentPickerContext` hook.
     *
     * Please check [OverlayProvider](https://github.com/GetStream/stream-chat-react-native/wiki/Cookbook-v3.0#overlayprovider) section in Cookbook
     * for more details.
     */
    bottomInset: number;
    bottomSheetRef: React.RefObject<BottomSheet | null>;
    closePicker: () => void;
    openPicker: () => void;
    setBottomInset: React.Dispatch<React.SetStateAction<number>>;
    setSelectedPicker: React.Dispatch<React.SetStateAction<'images' | undefined>>;
    setTopInset: React.Dispatch<React.SetStateAction<number>>;
    topInset: number;
    selectedPicker?: 'images';
};
export declare const AttachmentPickerContext: React.Context<AttachmentPickerContextValue>;
export declare const AttachmentPickerProvider: ({ children, value, }: PropsWithChildren<{
    value?: Pick<AttachmentPickerContextValue, "closePicker" | "openPicker"> & Partial<Pick<AttachmentPickerContextValue, "bottomInset" | "topInset">>;
}>) => React.JSX.Element;
export declare const useAttachmentPickerContext: () => AttachmentPickerContextValue;
//# sourceMappingURL=AttachmentPickerContext.d.ts.map